checked = false

FRAME_RATE = 60

local function Plr(pn)
	if GAMESTATE:IsPlayerEnabled(pn-1) then
		return SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn)
	else
		return nil
	end
end

local function getLife(pn)
	if GAMESTATE:IsPlayerEnabled(pn-1) then
		local life_meter = SCREENMAN:GetTopScreen():GetLifeMeter(pn-1)
		if life_meter then
			return SCREENMAN:GetTopScreen():GetLifeMeter(pn-1):GetLife()
		end
	end
	return nil
end

mod_firstSeenBeat = GAMESTATE:GetSongBeat() --necessary to prevent long freezes


curaction = 1
--{beat,thing,persists}

local life = {nil, nil}
local function FAIL()
	for pn = 1,2 do
		local b = Plr(pn)
		if b then
			local curLife = getLife(pn)
			if curLife > 0.19 then
				life[pn] = curLife
				b:SetLife(0.19) -- just enough to trigger danger
			end
		end
	end
end
	
local function LIVE()
	for pn = 1,2 do
		local b = Plr(pn)
		if b and life[pn] and getLife(pn) > 0 then 
			b:SetLife(life[pn])
		end
		life[pn] = nil
	end
end

mod_actions = {
  {106.5, FAIL},
  {107.75, LIVE},
  {302.5, FAIL},
  {303.75, LIVE},
}


function modtable_compare(a,b)
	return a[1] < b[1]
end

if table.getn(mod_actions) > 1 then
	table.sort(mod_actions, modtable_compare)
end

local ac = Def.ActorFrame{
	Name= "xtl_actor_d",
	Def.Actor{ OnCommand= function(s) mod_firstSeenBeat = GAMESTATE:GetSongBeat() s:sleep(9e9) end },
	Def.Actor{
		OnCommand=function(s) s:queuecommand('Update') end,
		UpdateCommand=function(self)
			if GAMESTATE:GetSongBeat()>=0 and not checked then
				for pn=1,2 do _G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil end
				screen = SCREENMAN:GetTopScreen()
				checked = true --let this only run once
			end
			local beat = GAMESTATE:GetSongBeat()
			disable = false
			if disable ~= true and beat > mod_firstSeenBeat+0.1 and checked then
				while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
					if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
						if type(mod_actions[curaction][2]) == 'function' then
							mod_actions[curaction][2]()
						elseif type(mod_actions[curaction][2]) == 'string' then
							MESSAGEMAN:Broadcast(mod_actions[curaction][2])
						end
					end
					curaction = curaction+1
				end
			end
			self:sleep(1/FRAME_RATE)
			self:queuecommand('Update')
		end,
	}
}

return ac